VERSION 1.0 CLASS
BEGIN
  MultiUse = -1  'True
  Persistable = 0  'NotPersistable
  DataBindingBehavior = 0  'vbNone
  DataSourceBehavior  = 0  'vbNone
  MTSTransactionMode  = 0  'NotAnMTSObject
END
Attribute VB_Name = "clsItem"
Attribute VB_GlobalNameSpace = False
Attribute VB_Creatable = False
Attribute VB_PredeclaredId = False
Attribute VB_Exposed = False
Private Declare Sub API_CopyMemory Lib "kernel32.dll" Alias "RtlMoveMemory" _
   (ByVal lpDestination As Long, ByVal lpSource As Long, ByVal Length As Long)

Private sText As String
Private sFullText As String
'storing the parent as long does not increment the reference counter of the Parent Object:
Private lpParent As Long
Private lIndex As Long
Public Tag As Variant

Property Let Text(Text As String)
   sText = Text
   sFullText = Text
   
   If lpParent <> 0 Then
      Call Me.Parent.UpdateDisplay(lIndex)
   End If
End Property

Property Get Text() As String
   Text = sText
End Property

Property Let ColorText(Text As String)
   If lpParent <> 0 Then
      sFullText = Text
      sText = Me.Parent.remove_ALL_COLOR_DATA(Text)
      Call Me.Parent.UpdateDisplay(lIndex)
   Else
      Err.Raise 1, , "Set Parent first !"
   End If
End Property

Property Get ColorText() As String
   ColorText = sFullText
End Property

Property Get Parent() As clsColoredListbox
   If lpParent <> 0 Then
      Set Parent = modSecureSubclassing.GetObjectFromRef(lpParent)
   Else
      Set Parent = Nothing
   End If
End Property

Property Get Index() As Long
   Index = lIndex
End Property


Friend Sub SetParent(Parent As clsColoredListbox)
   If lpParent <> 0 Then
      Err.Raise 1, , "Parent allready set !"
   Else
      lpParent = ObjPtr(Parent)
   End If
End Sub


Friend Sub SetIndex(ByVal Value As Long)
   lIndex = Value
End Sub

Friend Sub SetColorText(Text As String)
'does the same as let ColorText, but does'nt update the display
   If lpParent <> 0 Then
      sFullText = Text
      sText = Me.Parent.remove_ALL_COLOR_DATA(Text)
   Else
      Err.Raise 1, , "Set Parent first !"
   End If
End Sub

